"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const option_1 = require("@reactive-js/option");
const parser_combinators_1 = require("@reactive-js/parser-combinators");
const pipe_1 = require("@reactive-js/pipe");
exports.entityTagToString = ({ isWeak, tag }) => isWeak ? `\\W"${tag}"` : `"${tag}"`;
const pETagc = parser_combinators_1.satisfy(c => c >= 33 && c <= 256 && c !== 34);
const parseIsWeak = parser_combinators_1.optional(parser_combinators_1.string("W/"));
const parseTag = parser_combinators_1.manySatisfy()(pETagc);
exports.pETag = (charStream) => {
    const isWeak = pipe_1.pipe(charStream, parseIsWeak, option_1.isSome);
    parser_combinators_1.pDquote(charStream);
    const tag = parseTag(charStream);
    parser_combinators_1.pDquote(charStream);
    return { isWeak, tag };
};
exports.parseETag = parser_combinators_1.parseWith(exports.pETag);
exports.parseETagOrThrow = parser_combinators_1.parseWithOrThrow(exports.pETag);
//# sourceMappingURL=entityTag.js.map