import { Operator } from "@reactive-js/pipe";
import { HttpMethod, URILike, HttpHeaders, HttpRequest, HttpResponse, HttpServerRequest, CacheDirective, EntityTag, HttpContentEncoding, MediaRange } from "./interfaces";
export declare const createHttpRequest: <T>(method: HttpMethod, uri: string | URILike, { cacheControl, content, expectContinue, headers, httpVersionMajor, httpVersionMinor, preconditions, preferences, ...rest }?: {
    cacheControl?: readonly (string | CacheDirective)[] | undefined;
    content?: T | undefined;
    expectContinue?: boolean | undefined;
    headers?: import("@reactive-js/option").Option<HttpHeaders>;
    httpVersionMajor?: number | undefined;
    httpVersionMinor?: number | undefined;
    preconditions?: {
        ifMatch?: "*" | (string | EntityTag)[] | undefined;
        ifModifiedSince?: string | number | Date | undefined;
        ifNoneMatch?: "*" | (string | EntityTag)[] | undefined;
        ifUnmodifiedSince?: string | number | Date | undefined;
        ifRange?: string | number | EntityTag | Date | undefined;
    } | undefined;
    preferences?: {
        acceptedCharsets?: import("@reactive-js/option").Option<readonly string[]>;
        acceptedEncodings?: readonly HttpContentEncoding[] | undefined;
        acceptedLanguages?: import("@reactive-js/option").Option<readonly string[]>;
        acceptedMediaRanges?: readonly (string | MediaRange)[] | undefined;
    } | undefined;
}) => HttpRequest<T>;
export declare const createRedirectHttpRequest: <TReq, TResp>(response: HttpResponse<TResp>) => Operator<HttpRequest<TReq>, HttpRequest<TReq>>;
export declare const parseHttpRequestFromHeaders: <T>({ method, path, headers, httpVersionMajor, httpVersionMinor, isTransportSecure, body, }: {
    method: HttpMethod;
    path: string;
    headers: HttpHeaders;
    body: T;
    httpVersionMajor: number;
    httpVersionMinor: number;
    isTransportSecure: boolean;
}) => HttpServerRequest<T>;
export declare const writeHttpRequestHeaders: <T>({ cacheControl, content, expectContinue, headers, preconditions, preferences, }: HttpRequest<import("./interfaces").HttpContent<T>>, writeHeader: (header: string, value: string) => void) => void;
export declare const disallowProtocolAndHostForwarding: <T>() => Operator<HttpServerRequest<T>, HttpServerRequest<T>>;
export declare const httpRequestToUntypedHeaders: (request: HttpRequest<import("./interfaces").HttpContent<unknown>>) => {
    [key: string]: string;
};
