import { Operator } from "@reactive-js/pipe";
import { HttpStatusCode, HttpHeaders, URILike, HttpResponse, HttpRequest, EntityTag, CacheDirective, HttpContentEncoding, MediaRange } from "./interfaces";
export declare const createHttpResponse: <T>(statusCode: HttpStatusCode, { cacheControl, content, etag, expires, headers, lastModified, location, preferences, vary, ...rest }?: {
    cacheControl?: readonly (string | CacheDirective)[] | undefined;
    content?: T | undefined;
    etag?: string | EntityTag | undefined;
    expires?: number | undefined;
    headers?: import("@reactive-js/option").Option<HttpHeaders>;
    lastModified?: string | number | Date | undefined;
    location?: string | URILike | undefined;
    preferences?: {
        acceptedCharsets?: import("@reactive-js/option").Option<readonly string[]>;
        acceptedEncodings?: readonly HttpContentEncoding[] | undefined;
        acceptedLanguages?: import("@reactive-js/option").Option<readonly string[]>;
        acceptedMediaRanges?: readonly (string | MediaRange)[] | undefined;
    } | undefined;
    vary?: import("@reactive-js/option").Option<readonly string[]>;
}) => HttpResponse<T>;
export declare const parseHttpResponseFromHeaders: <T>(statusCode: number, headers: HttpHeaders, body: T) => HttpResponse<import("./interfaces").HttpContent<T>>;
export declare const writeHttpResponseHeaders: <T>(response: HttpResponse<import("./interfaces").HttpContent<T>>, writeHeader: (header: string, value: string) => void) => void;
export declare const checkIfNotModified: <T>({ cacheControl, method, preconditions, }: HttpRequest<unknown>) => Operator<HttpResponse<T>, HttpResponse<T>>;
//# sourceMappingURL=httpResponse.d.ts.map